- [HTTP request](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instanceGroupManagers/listPerInstanceConfigs#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instanceGroupManagers/listPerInstanceConfigs#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instanceGroupManagers/listPerInstanceConfigs#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instanceGroupManagers/listPerInstanceConfigs#body.request_body)
- [Response body](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instanceGroupManagers/listPerInstanceConfigs#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instanceGroupManagers/listPerInstanceConfigs#body.InstanceGroupManagersListPerInstanceConfigsResp.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instanceGroupManagers/listPerInstanceConfigs#body.InstanceGroupManagersListPerInstanceConfigsResp.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instanceGroupManagers/listPerInstanceConfigs#body.InstanceGroupManagersListPerInstanceConfigsResp.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION.internal_ips.map_entry1.value.SCHEMA_REPRESENTATION)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instanceGroupManagers/listPerInstanceConfigs#body.InstanceGroupManagersListPerInstanceConfigsResp.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION.external_ips.map_entry1.value.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instanceGroupManagers/listPerInstanceConfigs#body.InstanceGroupManagersListPerInstanceConfigsResp.SCHEMA_REPRESENTATION.warning.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instanceGroupManagers/listPerInstanceConfigs#body.aspect)
- [Try it!](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instanceGroupManagers/listPerInstanceConfigs#try-it)

Lists all of the per-instance configurations defined for the managed instance group. The `orderBy` query parameter is not supported.

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-east1 us-east4 us-east5 us-south1 us-west1 us-west2 us-west3 us-west4   
`POST https://compute.googleapis.com/compute/v1/projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/listPerInstanceConfigs`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Project ID for this request. |
| `zone` | `string` The name of the [zone](https://docs.cloud.google.com/compute/docs/regions-zones#available) where the managed instance group is located. It should conform to RFC1035. |
| `instanceGroupManager` | `string` The name of the managed instance group. It should conform to RFC1035. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `instanceGroupManager`: - `compute.instanceGroupManagers.get` |

### Query parameters

| Parameters ||
|---|---|
| `maxResults` | `integer (https://developers.google.com/discovery/v1/type-format format)` The maximum number of results per page that should be returned. If the number of available results is larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`) |
| `pageToken` | `string` Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list request to get the next page of results. |
| `filter` | `string` A filter expression that filters resources listed in the response. Most Compute resources support two types of filter expressions: expressions that support regular expressions and expressions that follow API improvement proposal [AIP-160](https://google.aip.dev/160). These two types of filter expressions cannot be mixed in one request. If you want to use AIP-160, your expression must specify the field name, an operator, and the value that you want to use for filtering. The value must be a string, a number, or a boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or `:`. For example, if you are filtering Compute Engine instances, you can exclude instances named `example-instance` by specifying `name != example-instance`. The `:*` comparison can be used to test whether a key has been defined. For example, to find all objects with `owner` label use: labels.owner:* You can also filter nested fields. For example, you could specify `scheduling.automaticRestart = false` to include instances only if they are not scheduled for automatic restarts. You can use filtering on nested fields to filter based on [resource labels](https://docs.cloud.google.com/compute/docs/labeling-resources). To filter on multiple expressions, provide each separate expression within parentheses. For example: (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") By default, each expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For example: (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true) If you want to use a regular expression, use the `eq` (equal) or `ne` (not equal) operator against a single un-parenthesized expression with or without quotes or against multiple parenthesized expressions. Examples: `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'` `fieldname eq "double quoted literal"` `(fieldname1 eq literal) (fieldname2 ne "literal")` The literal value is interpreted as a regular expression using Google [RE2](https://github.com/google/re2/wiki/Syntax) library syntax. The literal value must match the entire field. For example, to filter for instances that do not end with name "instance", you would use `name ne .*instance`. You cannot combine constraints on multiple fields using regular expressions. |
| `orderBy` | `string` Sorts list results by a certain order. By default, results are returned in alphanumerical order based on the resource name. You can also sort results in descending order based on the creation timestamp using `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse chronological order (newest result first). Use this to sort resources like operations so that the newest operation is returned first. Currently, only sorting by `name` or `creationTimestamp desc` is supported. |
| `returnPartialSuccess` | `boolean` Opt-in for partial success behavior which provides partial results in case of failure. The default value is false. For example, when partial success behavior is enabled, aggregatedList for a single zone scope either returns all resources in the zone or no resources, with an error code. |

### Request body

The request body must be empty.

### Response body

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "items": [ { "name": string, "preservedState": { "disks": { string: { "source": string, "mode": enum, "autoDelete": enum }, ... }, "metadata": { string: string, ... }, "internalIPs": { string: { "autoDelete": enum, "ipAddress": { "literal": string, "address": string } }, ... }, "externalIPs": { string: { "autoDelete": enum, "ipAddress": { "literal": string, "address": string } }, ... } }, "status": enum, "fingerprint": string } ], "nextPageToken": string, "warning": { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] } } ``` |

| Fields ||
|---|---|
| `items[]` | `object` Output only. The list of PerInstanceConfig. |
| `items[].name` | `string` The name of a per-instance configuration and its corresponding instance. Serves as a merge key during `instanceGroupManagers.updatePerInstanceConfigs` operations, that is, if a per-instance configuration with the same name exists then it will be updated, otherwise a new one will be created for the VM instance with the same name. An attempt to create a per-instance configuration for a VM instance that either doesn't exist or is not part of the group will result in an error. |
| `items[].preservedState` | `object` The intended preserved state for the given instance. Does not contain preserved state generated from a stateful policy. |
| `items[].preservedState.disks[]` | `map (key: string, value: object)` Preserved disks defined for this instance. This map is keyed with the device names of the disks. |
| `items[].preservedState.disks[].source` | `string` The URL of the disk resource that is stateful and should be attached to the VM instance. |
| `items[].preservedState.disks[].mode` | `enum` The mode in which to attach this disk, either `READ_WRITE` or `READ_ONLY`. If not specified, the default is to attach the disk in `READ_WRITE` mode. |
| `items[].preservedState.disks[].autoDelete` | `enum` These stateful disks will never be deleted during autohealing, update, instance recreate operations. This flag is used to configure if the disk should be deleted after it is no longer used by the group, e.g. when the given instance or the whole MIG is deleted. Note: disks attached in `READ_ONLY` mode cannot be auto-deleted. |
| `items[].preservedState.metadata` | `map (key: string, value: string)` Preserved metadata defined for this instance. |
| `items[].preservedState.internalIPs[]` | `map (key: string, value: object)` Preserved internal IPs defined for this instance. This map is keyed with the name of the network interface. |
| `items[].preservedState.internalIPs[].autoDelete` | `enum` These stateful IPs will never be released during autohealing, update or VM instance recreate operations. This flag is used to configure if the IP reservation should be deleted after it is no longer used by the group, e.g. when the given instance or the whole group is deleted. |
| `items[].preservedState.internalIPs[].ipAddress` | `object` Ip address representation |
| `items[].preservedState.internalIPs[].ipAddress.literal` | `string` An IPv4 internal network address to assign to the instance for this network interface. |
| `items[].preservedState.internalIPs[].ipAddress.address` | `string` The URL of the reservation for this IP address. |
| `items[].preservedState.externalIPs[]` | `map (key: string, value: object)` Preserved external IPs defined for this instance. This map is keyed with the name of the network interface. |
| `items[].preservedState.externalIPs[].autoDelete` | `enum` These stateful IPs will never be released during autohealing, update or VM instance recreate operations. This flag is used to configure if the IP reservation should be deleted after it is no longer used by the group, e.g. when the given instance or the whole group is deleted. |
| `items[].preservedState.externalIPs[].ipAddress` | `object` Ip address representation |
| `items[].preservedState.externalIPs[].ipAddress.literal` | `string` An IPv4 internal network address to assign to the instance for this network interface. |
| `items[].preservedState.externalIPs[].ipAddress.address` | `string` The URL of the reservation for this IP address. |
| `items[].status` | `enum` The status of applying this per-instance configuration on the corresponding managed instance. |
| `items[].fingerprint` | `string (https://developers.google.com/discovery/v1/type-format format)` Fingerprint of this per-instance config. This field can be used in optimistic locking. It is ignored when inserting a per-instance config. An up-to-date fingerprint must be provided in order to update an existing per-instance configuration or the field needs to be unset. A base64-encoded string. |
| `nextPageToken` | `string` Output only. This token allows you to get the next page of results for list requests. If the number of results is larger than `maxResults`, use the `nextPageToken` as a value for the query parameter `pageToken` in the next list request. Subsequent list requests will have their own `nextPageToken` to continue paging through the results. |
| `warning` | `object` Output only. Informational warning message. |
| `warning.code` | `enum` Output only. A warning code, if applicable. For example, Compute Engine returns `NO_RESULTS_ON_PAGE` if there are no results in the response. |
| `warning.message` | `string` Output only. A human-readable description of the warning code. |
| `warning.data[]` | `object` Output only. Metadata about this warning in `key: value` format. For example: ```html "data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }] ``` <br /> |
| `warning.data[].key` | `string` Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be `scope` and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding). |
| `warning.data[].value` | `string` Output only. A warning data value corresponding to the key. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/compute.readonly`
- `
  https://www.googleapis.com/auth/compute`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).